let kappa = document.getElementById('kappa'),
    amplitude = document.getElementById('amplitude'),
    cylinder_m = document.getElementById('cylinder_m'),
    cylinder_d = document.getElementById('cylinder_d'),
    ring_m = document.getElementById('ring_m'),
    ring_d1 = document.getElementById('ring_d1'),
    ring_d2 = document.getElementById('ring_d2'),
    stick_m = document.getElementById('stick_m'),
    stick_length = document.getElementById('length'),
    ball_m = document.getElementById('ball_m'),
    ball_d = document.getElementById('ball_d'),
    ball_x = document.getElementById('ball_x'),
    drawing = document.getElementById('canvas'),
    context = drawing.getContext('2d'),
    play = document.getElementById('play'),
    timer = document.getElementById('timer'),
    info = document.getElementById('info');

let is_pause = true,
    start_time = new Date().valueOf() / 1000,
    ori_time = 0,
    time = ori_time,
    cur_state = 'cylinder';
info.innerText = "圆柱元件 质量：" + cylinder_m.value + "g, 直径：" + cylinder_d.value + "cm";

let getInertia = () => cylinder_m.value * cylinder_d.value ^ 2 / 8,
    drawItem = function () {
        context.beginPath();
        context.fillStyle = "#339EDB"
        context.arc(0, 0, cylinder_d.value * drawing.height / 60, 0, 360);
        context.fill();
        context.closePath();
        context.beginPath();
        context.fillStyle = "white";
        context.arc(cylinder_d.value * drawing.height / 60 * 0.8, 0, 4, 0, 360);
        context.fill();
        context.closePath();
    };

function changeTimer() {
    if (is_pause) {
        start_time = new Date().valueOf() / 1000;
        play.classList.replace('fa-play', 'fa-pause');
    } else {
        ori_time = time;
        play.classList.replace('fa-pause', 'fa-play');
    }
    is_pause = !is_pause;
}

function reset() {
    time = 0;
    ori_time = 0;
    timer.innerText = "00:00.000";
    if (!is_pause) {
        play.classList.replace('fa-pause', 'fa-play');
        is_pause = true;
    }
}

function changeStates(obj) {
    let state = obj.children[0].id;
    // noinspection JSUnresolvedVariable
    eval('is_' + state + '= true;');
    eval("cur_state = " + state + ".id");

    switch (cur_state) {
        case "cylinder":
            getInertia = () => cylinder_m.value * cylinder_d.value ^ 2 / 8;
            drawItem = function () {
                context.beginPath();
                context.fillStyle = "#339EDB"
                context.arc(0, 0, cylinder_d.value * drawing.height / 60, 0, 360);
                context.fill();
                context.closePath();
                context.beginPath();
                context.fillStyle = "white";
                context.arc(cylinder_d.value * drawing.height / 60 * 0.8, 0, 4, 0, 360);
                context.fill();
                context.closePath();
            };
            info.innerText = "圆柱元件 质量：" + cylinder_m.value + "g, 直径：" + cylinder_d.value + "cm";
            break;
        case "ring":
            getInertia = () => ring_m.value * (ring_d1.value ^ 2 + ring_d2.value ^ 2) / 8;
            drawItem = function () {
                context.beginPath();
                context.fillStyle = "#339EDB"
                context.arc(0, 0, ring_d1.value * drawing.height / 60, 0, 360);
                context.fill();
                context.closePath();
                context.beginPath();
                context.fillStyle = "white";
                context.arc(0, 0, ring_d2.value * drawing.height / 60, 0, 360);
                context.fill();
                context.closePath();
                context.beginPath();
                context.fillStyle = "white";
                context.arc((parseInt(ring_d1.value) + parseInt(ring_d2.value)) * drawing.height / 120 * 0.95, 0, 4, 0, 360);
                context.fill();
                context.closePath();
            };
            info.innerText = "圆环元件 质量：" + ring_m.value + "g, 直径1：" + ring_d1.value + "cm, 直径2：" + ring_d2.value + "cm";
            break;
        case "stick":
            getInertia = () => (stick_m.value * stick_length.value ^ 2 / 12) + (ball_m.value * (ball_d.value ^ 2 / 10 + ball_x.value ^ 2));
            drawItem = function () {
                context.fillStyle = "#339EDB"
                context.fillRect(-stick_length.value * drawing.height / 120, -2, stick_length.value * drawing.height / 60, 4);
                context.beginPath();
                context.fillStyle = "black";
                context.arc(ball_x.value * drawing.height / 60, 0, ball_d.value * drawing.height / 120, 0, 360);
                context.fill();
                context.closePath();
                context.beginPath();
                context.fillStyle = "black";
                context.arc(-ball_x.value * drawing.height / 60, 0, ball_d.value * drawing.height / 120, 0, 360);
                context.fill();
                context.closePath();
            };
            info.innerText = "长杆元件 质量：" + stick_m.value + "g, 长度：" + stick_length.value + "cm, 小球质量：" +
                ball_m.value + "g, 小球直径：" + ball_d.value + "cm, 小球位置：" + ball_x.value + "cm";
            break;
    }
}

function drawCanvas() {
    requestAnimationFrame(drawCanvas);
    if (!is_pause) {
        time = ori_time + new Date().valueOf() / 1000 - start_time;
        let minute = Math.floor(time / 60).toString().padStart(2, '0');
        let second = (time % 60).toFixed(3).toString().padStart(6, '0');
        timer.innerText = minute + ':' + second;
    }
    let theta = amplitude.value / 180 * Math.PI * Math.cos(Math.sqrt(kappa.value / getInertia() * 1e7) * time);
    context.clearRect(0, 0, drawing.width, drawing.height);
    context.translate(drawing.width / 2, drawing.height / 2);
    context.save();
    context.rotate(theta);
    drawItem();
    context.rotate(-theta);
    context.restore();
    context.translate(-drawing.width / 2, -drawing.height / 2);
}

$(function () {
    $('[data-toggle="tooltip"]').tooltip()
})


drawCanvas();
